From 96823453fc43d6e8399782d726d1482b2d2c507e Mon Sep 17 00:00:00 2001
From: Ralph Bean <rbean@redhat.com>
Date: Mar 15 2016 15:01:13 +0000
Subject: [PATCH 331/1001] Merge #111 `Fixes #10 : Added the subscribed_to stats and Subscribe/Unsubscribe button`


---

diff --git a/hubs/tests/test_widgets/test_fedmsgstats.py b/hubs/tests/test_widgets/test_fedmsgstats.py
index ad8c0c3..39bd99e 100644
--- a/hubs/tests/test_widgets/test_fedmsgstats.py
+++ b/hubs/tests/test_widgets/test_fedmsgstats.py
@@ -16,7 +16,11 @@ class TestFedmsgStats(hubs.tests.test_widgets.WidgetTest):
             u'fedmsgs': 83854,
             u'fedmsgs_text': u'83,854',
             u'source_url': u'/source/fedmsgstats/',
-            u'subscribers': 0,
+            u'subscribers': [],
+            u'subscribed_to': [],
             u'subscribers_text': u'0',
+            u'subscribed_text': u'0',
             u'username': u'ralph',
+            u'hub_subscribe_url': u'/api/hub/ralph/subscribe',
+            u'hub_unsubscribe_url': u'/api/hub/ralph/unsubscribe',
         })
diff --git a/hubs/widgets/fedmsgstats.py b/hubs/widgets/fedmsgstats.py
index b81a2cd..a71f1b0 100755
--- a/hubs/widgets/fedmsgstats.py
+++ b/hubs/widgets/fedmsgstats.py
@@ -3,6 +3,7 @@ from hubs.widgets.chrome import panel
 
 from hubs.utils import commas
 
+import flask
 import jinja2
 import requests
 
@@ -16,13 +17,21 @@ template = jinja2.Template("""
 <div class="stats-container row">
   <div class="col-sm-7 col-md-12 col-lg-7">
   <table class="stats-table">
-    <tr><th>FedMsgs</th><th>Subscribers</th></tr>
-    <tr class="text-info"><td>{{fedmsgs_text}}</td><td class="text-right">{{subscribers_text}}</td></tr>
+    <tr><th>subscribers</th><th>Subscribed_to</th></tr>
+    <tr class="text-info"><td>{{subscribers_text}}</td><td class="text-center">{{subscribed_text}}</td></tr>
   </table>
   </div>
   <div class="col-sm-5 col-md-12 col-lg-5">
   {% if session['nickname'] != username %}
-  <div class="pull-right"><button class="btn btn-info">Subscribe</button></div>
+    {% if session['nickname'] in subscribers %}
+    <li><form action="{{hub_unsubscribe_url}}" method="POST">
+        <button class="btn btn-info"><span class="glyphicon glyphicon-remove-sign" aria-hidden="true"></span> Unsubscribe</button>
+    </form></li>
+    {% else %}
+    <li><form action="{{hub_subscribe_url}}" method="POST">
+        <button class="btn btn-default"><span class="glyphicon glyphicon-plus" aria-hidden="true"></span> Subscribe</button>
+    </form></li>
+    {% endif %}
   {% endif %}
   </div>
 </div>
@@ -34,12 +43,19 @@ def data(session, widget, username):
     url = url.format(username=username)
     response = requests.get(url)
     fedmsgs = response.json()['total']
+    for assoc in widget.hub.associations:
+        sub_list = [u.name for u in assoc.user.subscriptions]
+    subscribers = [u.username for u in widget.hub.subscribers]
     return dict(
         username=username,
         fedmsgs=fedmsgs,
-        subscribers=len(widget.hub.subscribers),
+        subscribers=subscribers,
+        subscribed_to=sub_list,
         fedmsgs_text=commas(fedmsgs),
-        subscribers_text=commas(len(widget.hub.subscribers)),
+        subscribers_text=commas(len(subscribers)),
+        subscribed_text=commas(len(sub_list)),
+        hub_subscribe_url=flask.url_for('hub_subscribe', hub=widget.hub.name),
+        hub_unsubscribe_url=flask.url_for('hub_unsubscribe', hub=widget.hub.name),
     )
 
 

